import es
import popuplib
import gamethread
import cmdlib

hitmarker = {}
flashed = set()

info = es.AddonInfo()
info.name = 'Hitmarker'
info.basename = 'hitmarker'
info.version = '2.0'
info.author = 'h!gh voltage'
info.description = 'Shows a hitmarker when you hit an enemy.'
es.ServerVar('hitmarker_version', info.version).makepublic()


hitmarker_enabled = 1
damage_enabled = 1

def load():
    cmdlib.registerSayCommand('!hitmarker', hitmarkerCmd, "Hitmarker Say Command")
    for x in es.getUseridList():
        uid = es.getplayersteamid(x)
        if uid not in hitmarker:
            hitmarker[uid] = {}
            if hitmarker_enabled:
                hitmarker[uid]['enabled'] = 1
            if damage_enabled:
                hitmarker[uid]['damage'] = 1
                hitmarker[uid]['hudmid'] = 0
                hitmarker[uid]['hudright'] = 1

def unload():
    cmdlib.unregisterSayCommand('!hitmarker')

def player_activate(ev):
    uid = int(ev['userid'])
    sid = es.getplayersteamid(uid)
    es.stringtable('downloadables','materials/overlays/hitmarker/hitmarkerv2.vtf')
    es.stringtable('downloadables','materials/overlays/hitmarker/hitmarkerv2.vmt')
    hitmarker[sid] = {}
    if hitmarker_enabled:
        hitmarker[sid]['enabled'] = 1
    if damage_enabled:
        hitmarker[sid]['damage'] = 1
        hitmarker[sid]['hudmid'] = 0
        hitmarker[sid]['hudright'] = 1
    if hitmarker_enabled == 1:
        gamethread.delayed(5, es.tell(uid, '#multi', '#green[ #lightgreenHitmarker #green] Type #lightgreen!hitmarker #greenin chat to open the hitmarker menu.'))

def player_disconnect(ev):
    uid = int(ev['userid'])
    if uid in hitmarker:
        del hitmarker[uid]

def hitmarkerCmd(userid, args):
    hitmarker = popuplib.create('hm_menu')
    hitmarker.addline('Hitmarker Settings')
    hitmarker.addline(' ')
    hitmarker.addline('->1. Hitmarker on/off')
    hitmarker.addline('->2. Damage Display on/off')
    hitmarker.addline('->3. Damage Display type')
    hitmarker.addline(' ')
    hitmarker.addline('0. Close')
    hitmarker.unsend(userid)
    hitmarker.send(userid)
    hitmarker.delete()
    hitmarker.menuselect = hitmarkerSelect

def damagetype(userid, args):
    damage = popuplib.create('damage_type')
    damage.addline('Damage Display Type Settings')
    damage.addline(' ')
    damage.addline('->1. Mid-Screen')
    damage.addline('->2. Right-Screen')
    damage.addline(' ')
    damage.addline('->9. Back')
    damage.addline('0. Close')
    damage.unsend(userid)
    damage.send(userid)
    damage.delete()
    damage.menuselect = damageSelect

def hitmarkerSelect(userid, choice, popupid):
    sid = es.getplayersteamid(userid)
    if choice == 1:
        if hitmarker_enabled == 1:
            if hitmarker[sid]['enabled'] == 0:
                hitmarker[sid]['enabled'] = 1
                es.tell(userid, '#multi', '#greenYou turned the #lightgreenhitmarker #greenon.')
            else:
                hitmarker[sid]['enabled'] = 0
                es.tell(userid, '#multi', '#greenYou turned the #lightgreenhitmarker #greenoff.')
        else: es.tell(userid, '#multi', '#lightgreenHitmarker #greenis currently disabled.')
    elif choice == 2:
        if damage_enabled == 1:
            if hitmarker[sid]['damage'] == 0:
                hitmarker[sid]['damage'] = 1
                es.tell(userid, '#multi', '#greenYou turned the #lightgreendamage display #greenon.')
            else:
                hitmarker[sid]['damage'] = 0
                es.tell(userid, '#multi', '#greenYou turned the #lightgreendamage display #greenoff.')
        else: es.tell(userid, '#multi', '#lightgreenDamage Display #greenis currently disabled.')
    elif choice == 3:
        if damage_enabled == 1:
            damagetype(userid, None)
        else: 
            es.tell(userid, '#multi', '#lightgreenDamage Display #greenis currently disabled.')
            hitmarkerCmd(userid, None)
    if choice in (1, 2):
        hitmarkerCmd(userid, None)

def damageSelect(userid, choice, popupid):
    sid = es.getplayersteamid(userid)
    if choice == 1:
        if hitmarker[sid]['hudmid'] == 0:
            hitmarker[sid]['hudright'] = 0
            hitmarker[sid]['hudmid'] = 1
            es.tell(userid, '#multi', '#greenYou set your damage display to #lightgreenmid-screen#green.')
    elif choice == 2:
        if hitmarker[sid]['hudright'] == 0:
            hitmarker[sid]['hudmid'] = 0
            hitmarker[sid]['hudright'] = 1
            es.tell(userid, '#multi', '#greenYou set your damage display to #lightgreenright-screen#green.')
    elif choice == 9:
        hitmarkerCmd(userid, None)
    if choice in (1, 2):
        damagetype(userid, None)

def hudhint(userid, text):
    es.usermsg("create", "_hint_text", "HintText")
    es.usermsg("write",  "string", "_hint_text", str(text))
    es.usermsg("send",   "_hint_text", userid)
    es.usermsg("delete", "_hint_text")

def keyhint(userid, text):
    es.usermsg("create", "hinttext", "KeyHintText")
    es.usermsg("write",  "byte", "hinttext", 1)
    es.usermsg("write",  "string", "hinttext", str(text))
    es.usermsg("send",   "hinttext", userid)
    es.usermsg("delete", "hinttext")

def player_hurt(ev):
    aid = ev['attacker']
    sid = es.getplayersteamid(aid)
    if hitmarker_enabled == 1:
        if hitmarker[sid]['enabled'] == 1:
            es.cexec(aid,"r_screenoverlay overlays/hitmarker/hitmarkerv2")
            gamethread.delayed(0.5, es.cexec, (aid,"r_screenoverlay","0"))
    if damage_enabled == 1:
        if hitmarker[sid]['damage'] == 1:
            if hitmarker[sid]['hudright'] == 1:
                keyhint(aid, 'Victim: %s\nDamage: %s\nHealth left: %s'%(ev['es_username'],ev['dmg_health'], ev['health']))
            if hitmarker[sid]['hudmid'] == 1:
                hudhint(aid, 'Victim: %s\nDamage: %s\nHealth left: %s'%(ev['es_username'],ev['dmg_health'], ev['health']))

def player_blind(ev):
    if hitmarker_enabled == 1:
        flashed.add(ev['es_username'])

def flashbang_detonate(ev):
    flasher = ev['userid']
    sid = es.getplayersteamid(flasher)
    if not flashed:
        if damage_enabled == 1:
            if hitmarker[sid]['damage'] == 1:
                if hitmarker[sid]['hudright'] == 1:
                    keyhint(flasher, 'Your flashbang was worthless.')
                if hitmarker[sid]['hudmid'] == 1:
                    hudhint(flasher, 'Your flashbang was worthless.')
    else:
        if hitmarker_enabled == 1:
            if hitmarker[sid]['enabled'] == 1:
                es.cexec(flasher,"r_screenoverlay overlays/hitmarker/hitmarkerv2")
                gamethread.delayed(0.8, es.cexec, (flasher,"r_screenoverlay","0"))
        if damage_enabled == 1:
            if hitmarker[sid]['damage'] == 1:
                if hitmarker[sid]['hudright'] == 1:
                    keyhint(flasher, 'You blinded: \n%s' %('\n'.join(flashed)))
                if hitmarker[sid]['hudmid'] == 1:
                    hudhint(flasher, 'You blinded: \n%s' %('\n'.join(flashed)))
        flashed.clear()